#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#! File:        Ryb_Dll.TpL
#! Purpose:     Independent DLL Templates
#! Author:      2000.02.21 - Roberto Artigas Jr
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#TEMPLATE(zAppDll,'2002.06.29: Independent DLL Hookups'),FAMILY('ABC','Clarion')
#!
#!--------------------------------------------------------------------
#EXTENSION(PrototypeExporter,'2001.09.01: Prototype Exporter (ABC)'),APPLICATION
#!--------------------------------------------------------------------
#! Created By:  Roberto Artigas Jr
#!--------------------------------------------------------------------
#SHEET
  #TAB ('General')
    #DISPLAY('Template Chain: zAppDLL(Ryb_DLL.Tpl)')
    #DISPLAY('Template Name:  PrototypeExporter')
    #DISPLAY('')
    #BOXED('Prototype Exporter')
      #PROMPT('Include Filename:',@S13), %IncludeFilename, REQ, DEFAULT(UPPER(SLICE(%Program, 1, INSTRING('.', %Program, 1, 1)-1)) & '.RYB')
    #ENDBOXED
  #ENDTAB
#ENDSHEET
#!--------------------------------------------------------------------
#AT(%CustomGlobalDeclarations),WHERE(%ProgramExtension='DLL')
  #DECLARE(%TheOOPConstruct)
  #DECLARE(%TheBuildInclude)
  #SET(%TheBuildInclude,UPPER(SLICE(%Program, 1, INSTRING('.', %Program, 1, 1)-1)) & '.$$$')
  #CREATE(%TheBuildInclude)
!BOF
!
! File:         %IncludeFileName
! Purpose:      Include Of DLL Procedures
! Author:       Prototype Exporter
!
  #FOR(%Procedure),WHERE(%ProcedureExported)
    #INSERT(%MakeDeclr(ABC), 28, %TheOOPConstruct, %Procedure, %ProcedureType & %Prototype & ',DLL')
#!    #IF(%ProcedureDescription)
#!      #INSERT(%MakeDeclr(ABC), 55, %TheOOPConstruct, %OOPConstruct, '! ' & %ProcedureDescription)
#!    #ENDIF
%TheOOPConstruct
  #ENDFOR
!
!EOF
  #CLOSE(%TheBuildInclude)
  #REPLACE(%IncludeFilename, %TheBuildInclude)
  #REMOVE(%TheBuildInclude)
#ENDAT
#!

#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#! 2001.09.01 - Added Identification sectionc
#! 2000.02.21 - Roberto Artigas Jr
#EXTENSION(NoABCExports,'2001.09.01: Suppress GLOBAL Data and Exports (ABC)'),APPLICATION
#SHEET
  #TAB ('General')
    #DISPLAY('Template Chain: zAppDLL(Ryb_DLL.Tpl)')
    #DISPLAY('Template Name:  NoABCExports')
  #ENDTAB
#ENDSHEET
#!--------------------------------------------------------------------
#ATSTART
  #DECLARE(%HoldGlobalExternal)
#ENDAT
#AT(%BeginningExports)
  #SET(%HoldGlobalExternal,%GlobalExternal)
  #SET(%GlobalExternal,%True)
#ENDAT
#AT(%DLLExportList)
  #SET(%GlobalExternal,%HoldGlobalExternal)
#ENDAT
#!

#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#UTILITY (GenerateRecords, 'Generate Records'), WIZARD
#!--------------------------------------------------------------------
#PREPARE
#DECLARE (%RecOps), MULTI
#ADD(%RecOps,'GET')
#ADD(%RecOps,'PUT')
#ADD(%RecOps,'SET')
#ADD(%RecOps,'NEXT')
#ADD(%RecOps,'PREV')
#ENDPREPARE
#!--------------------------------------------------------------------
#SHEET
  #TAB ('Generate Records')
    #DISPLAY ('This wizard will generate group definitions of the contents of your current dictionary.'), AT(90, 8, 235, 24)
    #DISPLAY ('To specify how you want the report constructed, click on the Next button.'), AT(90)
  #ENDTAB
  #TAB ('Dictionary Print Wizard - Reported Files'), FINISH(1)
    #DISPLAY ('You can report on each file in your dictionary, or you can select individual files to report on.'), AT(90, 8, 235, 24)
    #PROMPT ('Report on all files in my dictionary.', CHECK), %DictionaryReportUseAllFiles, DEFAULT(1), AT(90,, 180)
  #ENDTAB
  #TAB ('Dictionary Print Wizard - Select Reported Files'), WHERE(~%DictionaryReportUseAllFiles), FINISH(1)
    #PROMPT ('File Selection', FROM (%File)), %DictionaryReportFileSelection, INLINE, SELECTION('File Selection'), AT(90, 8, 235)
  #ENDTAB
  #TAB ('Dictionary Print Wizard - Finally...')
    #DISPLAY ('This concludes the dictionary Group Generate wizard.'), AT(90, 8, 235, 24)
    #DISPLAY ('Click on the Finish button to generate Groups.'), AT(90, 82, 235, 24)
  #ENDTAB
#ENDSHEET
#COMMENT(45)
#DECLARE (%ReportedFiles),UNIQUE
#DECLARE (%Groups), MULTI
#DECLARE (%ValueConstruct)
#DECLARE (%TheKeyId)
#DECLARE (%TheKeyNo,LONG)
#IF (%DictionaryReportUseAllFiles)
  #FOR (%File)
    #ADD (%ReportedFiles, %File)
  #ENDFOR
#ELSE
  #FOR (%DictionaryReportFileSelection)
    #ADD (%ReportedFiles, %DictionaryReportFileSelection)
  #ENDFOR
#ENDIF
#DECLARE (%OutputFile)
#FOR (%ReportedFiles)
  #FIX (%File, %ReportedFiles)
  #SET (%OutputFile,%FILE&'.GRP')
  #MESSAGE('File Group Definition: ' & %OutputFile, 2)
  #CREATE (%OutputFile)
!BOF
!
! File:         %OutputFile
! Purpose:      Generated File Records as Groups
! Author:       GenerateRecords Template
! Narative:     This template is used to pass records structures
!               back and forth between DLL's when the files
!               are not shared. Since file definitions are not
!               available, data has to be passed in areas.
!
  #IF (%FileType = 'ALIAS')
! Name:         %File(An alias for %AliasFile)
  #ELSE
! Name:         %File
  #ENDIF
! Prefix:       %FilePrefix
  #IF (%FileDescription)
! Description:  %FileDescription
  #ENDIF
  #IF (%FileName)
! Filename:     %FileName
  #ENDIF
!
!-Keys-
  #SUSPEND
    #FOR (%Key)
! %[25]KeyID %|
      #FOR (%KeyField)
        #FIX (%Field, %KeyField)
        #IF (INSTANCE(%KeyField) = 1)
%FieldID(%KeyFieldSequence)
        #ELSE
!%[27]Null%FieldID(%KeyFieldSequence)
        #ENDIF
      #ENDFOR
    #ENDFOR
  #RESUME
!-Keys Equates-
  #SUSPEND
    #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
%[27]TheKeyId EQUATE(0)
    #SET(%TheKeyNo,1)
    #FOR (%Key)
      #FOR (%KeyField)
        #FIX (%Field, %KeyField)
          #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
%[27]TheKeyId EQUATE(%TheKeyNo)
          #SET(%TheKeyNo,%TheKeyNo+1)
      #ENDFOR
    #ENDFOR
  #RESUME
!-Keys-
  #SUSPEND
    #SET(%TheKeyNo,0)
    #FOR (%Key)
      #FOR (%KeyField)
        #FIX (%Field, %KeyField)
        #IF (INSTANCE(%KeyField) = 1)
          #!SET(%TheKeyId,SUB(%KeyID,1,INSTRING('_',%KeyID,1,1)-1))
          #SET(%TheKeyId,'Key'&%TheKeyNo)
%FilePrefix:mKey:%KeyID GROUP,BINDABLE,TYPE !,PRE(m%FilePrefix:%TheKeyId)
%FieldStruct #<! %FieldDescription
          #SET(%TheKeyNo,%TheKeyNo+1)
        #ELSE
%FieldStruct #<! %FieldDescription
        #ENDIF
      #ENDFOR
  END
    #ENDFOR
  #RESUME
!-Record Equates-
  #SUSPEND
    #SET(%TheKeyNo,1)
    #FOR (%RecOps)
      #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%RecOps))
%[27]TheKeyId EQUATE(%TheKeyNo)
      #SET(%TheKeyNo,%TheKeyNo+1)
    #ENDFOR
  #RESUME
!-Record-
  #SUSPEND
%FilePrefix:mRec GROUP,BINDABLE,TYPE !,PRE(m%FilePrefix)
    #FOR (%Field)
%FieldStruct #<! %FieldDescription
    #ENDFOR
  END
  #RESUME
!
!-Communication Area-
%FilePrefix:mCom GROUP,BINDABLE,TYPE !,PRE(c%FilePrefix)
Action LONG #<! What To Do
Result LONG #<! What The Result Was
KeyNum LONG #<! Key Number To Use
KeyDat STRING(255) #<! Key Holding Area
  #SUSPEND
    #SET(%TheKeyNo,0)
    #FOR (%Key)
      #FOR (%KeyField)
        #FIX (%Field, %KeyField)
          #SET(%TheKeyId,'Key'&%TheKeyNo)
%KeyID LIKE(%FilePrefix:mKey:%KeyID),OVER(KeyDat)
          #SET(%TheKeyNo,%TheKeyNo+1)
      #ENDFOR
    #ENDFOR
  #RESUME
ErrMsg STRING(255) #<! Error Message
  END
!
!EOF
#CLOSE (%OutputFile)
#ENDFOR
#!

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#EXTENSION(GenerateModules,'Generate Modules'),APPLICATION,MULTI
#!---------------------------------------------------------------------
#PREPARE
#ENDPREPARE
#!---------------------------------------------------------------------
#SHEET
  #TAB ('General')
    #DISPLAY('Template Chain: zAppDLL(Ryb_DLL.Tpl)')
    #DISPLAY('Template Name:  GenerateModules')
    #DISPLAY('')
    #BOXED('')
      #PROMPT('File Name:',FROM(%File)),%modFile,REQ,DEFAULT('')
    #ENDBOXED
  #ENDTAB
#ENDSHEET
#!---------------------------------------------------------------------
#COMMENT(45)
#!---------------------------------------------------------------------
#ATSTART
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
#!
#DECLARE(%RecOps), MULTI
#ADD(%RecOps,'GET')
#ADD(%RecOps,'PUT')
#ADD(%RecOps,'SET')
#ADD(%RecOps,'NEXT')
#ADD(%RecOps,'PREV')
#!
#DECLARE (%TheKeyId)
#DECLARE (%TheKeyNo,LONG)
#!
#DECLARE (%RaFileName, STRING)
#DECLARE (%RaClipName, STRING)
#DECLARE (%RaWorkName, STRING)
#!
#DECLARE(%ReportedFiles),UNIQUE
#DECLARE(%LocB,LONG)
#DECLARE(%LocE,LONG)
#!
#FOR (%File)
  #IF(%File=%modFile)
    #ADD (%ReportedFiles, %File)
  #END
#ENDFOR
#FOR (%ReportedFiles)
  #FIX (%File, %ReportedFiles)
  #SET (%RaClipName, %FilePrefix)
  #SET (%RaFileName, %RaClipName & '.clw')
  #SET (%RaWorkName, %RaClipName & '.$$$')
  #PROJECT (%RaFileName)
  #CREATE (%RaWorkName)
!BOF
!---------------------------------------------------------------------
!---------------------------------------------------------------------
! File:         %RaFileName
! Purpose:      File Access From Other DLL's and Exe's
!---------------------------------------------------------------------
  MEMBER('%Application.clw')

  INCLUDE('%File.GRP') #<! Memory Definition

!
! Procedure:    Driver_%FilePrefix
! Purpose:      Allow other DLL's and EXE's to my files
! Author:       Roberto Artigas Jr
! ASSUMES:      Files are already declared
!
Driver_%FilePrefix PROCEDURE(%FilePrefix_mCom, %FilePrefix_mRec)
  CODE
  LOCK(%File) #<! Wait until locked

  OPEN(%File)
  IF ERROR() THEN
    %FilePrefix_mCom.Result = ERRORCODE()
    %FilePrefix_mCom.ErrMsg = ERROR()
    RETURN
  END   

  CASE(%FilePrefix_mCom.Action)
  #SUSPEND
    #FOR (%RecOps)
      #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%RecOps))

    OF %TheKeyId
      #CASE(%RecOps)
      #OF('GET')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          GET(%File,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
          IF (%FilePrefix:%FieldId <> %FilePrefix_mCom.%KeyID.%FieldId) THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          #ENDFOR
        #ENDFOR
      END
      %FilePrefix_mRec :=: %FilePrefix:Record
      %FilePrefix_mCom.Result = ERRORCODE()
      %FilePrefix_mCom.ErrMsg = ERROR()
      #OF('PUT')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          GET(%File,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
          IF (%FilePrefix:%FieldId <> %FilePrefix_mCom.%KeyID.%FieldId) THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          #ENDFOR
        #ENDFOR
      END
      %FilePrefix:Record :=: %FilePrefix_mRec
      PUT(%File)
      %FilePrefix_mCom.Result = ERRORCODE()
      %FilePrefix_mCom.ErrMsg = ERROR()
      #OF('SET')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          SET(%FilePrefix:%KeyId,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #ENDFOR
      END
      #OF('NEXT')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          SET(%FilePrefix:%KeyId,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          NEXT(%File)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
          %FilePrefix_mCom.%KeyID.%FieldId = %FilePrefix:%FieldId
          #ENDFOR
        #ENDFOR
      END
      #OF('PREV')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          SET(%FilePrefix:%KeyId,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
          PREVIOUS(%File)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
          %FilePrefix_mCom.%KeyID.%FieldId = %FilePrefix:%FieldId
          #ENDFOR
        #ENDFOR
      END
      #ENDCASE
    #ENDFOR
  #RESUME
  END

  CLOSE(%File)
  IF ERROR() THEN
    %FilePrefix_mCom.Result = ERRORCODE()
    %FilePrefix_mCom.ErrMsg = ERROR()
  END   

  UNLOCK(%File) #<! Done with file
  RETURN

!---------------------------------------------------------------------
!---------------------------------------------------------------------
!EOF
#CLOSE (%RaWorkName)
#REPLACE (%RaFileName, %RaWorkName)
#REMOVE (%RaWorkName)
#ENDFOR
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%AfterGlobalIncludes)
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%GlobalMap)
MODULE('%RaFileName')
#INDENT(-5)
#FOR (%ReportedFiles)
  #FIX (%File, %ReportedFiles)
Driver_%FilePrefix PROCEDURE(*%FilePrefix:mCom, *%FilePrefix:mRec)
#ENDFOR
#INDENT(5)
END
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%GlobalData)
#ENDAT
#!---------------------------------------------------------------------

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#PROCEDURE(DLLSource,'2002.06.29: DLL Source Procedure (ABC)')
#!---------------------------------------------------------------------
#PROMPT('Debug Me? ',CHECK),%DebugMe,DEFAULT(0)
#PROMPT('Debug On? ',CHECK),%DebugOn,DEFAULT(0)
#PROMPT('Parameters: ',@s255),%Parameters,DEFAULT('pWhere')
#DISPLAY('The prototype should be at least defined as:')
#DISPLAY('(STRING),BYTE')
#DISPLAY('Otherwise you will get compile errors.')
#DISPLAY('')
#DISPLAY('Template Chain: DLLSource(zAppDLL)')
#DISPLAY('Template File:  RYB_DLL.TPL')
#!--------------------------------------------------------------------
#ATSTART
#CALL(%ReadABCFiles(ABC))
#ENDAT
#!---------------------------------------------------------------------
#DECLARE(%wrkVar1)
#DECLARE(%wrkVar2)
#!---------------------------------------------------------------------
#IF(%Parameters)
%[23]Procedure PROCEDURE  (%Parameters)
#ELSE
%[23]Procedure PROCEDURE  ()
#ENDIF
#!---------------------------------------------------------------------
!-----------------------------------------------------------------------------------!
! When you make a change, you are required to enter a change history entry.         !
! Change history entered lastest change first. Format is: ???.YYYY.MM.DD - <text>.  !
! Where: ??? are your initials, YYYY is the year, MM is the month, DD is the day,   !
! and <text> is some description of the changes you have made.                      !
!-----------------------------------------------------------------------------------!
#EMBED(%ChangeHistory,'Change History'),DATA,TREE('Change History{{PRIORITY(10)}')
#!---------------------------------------------------------------------
#INSERT(%FileControlInitialize(ABC))
#AT(%CustomGlobalDeclarations)
  #INSERT(%FileControlSetFlags(ABC))
#ENDAT
#!---------------------------------------------------------------------
#IF(%DebugMe)
#SET(%wrkVar1,'The_Debug')
#SET(%wrkVar2,'EQUATE(' & %DebugOn & ')')
%[23]wrkVar1 %wrkVar2
!
#ENDIF
#!---------------------------------------------------------------------
#FOR(%LocalData)
%[23]LocalData %LocalDataStatement
#ENDFOR
#!---------------------------------------------------------------------
#SET(%wrkVar1,'byteRc')
#SET(%wrkVar2,'BYTE(TRUE)')
%[23]wrkVar1 %wrkVar2
#!---------------------------------------------------------------------
#EMBED(%DataSection,'Data Section'),DATA,TREE('Local Data{{PRIORITY(1000)}')
  CODE
#IF(%DebugMe)
  COMPILE('!***DEBUG***', The_Debug)
  STOP('%Procedure [ENTRY]<13,10>Called By: ' & CLIP(pWhere) & '')
  !***DEBUG***
#ENDIF
#EMBED(%ProcessedCode,'Processed Code'),LABEL     #! Embedded Source Code
#!---------------------------------------------------------------------
#IF(%DebugMe)
  COMPILE('!***DEBUG***', The_Debug)
  STOP('%Procedure [EXITS]<13,10>Called By: ' & CLIP(pWhere) & '<13,10>RETURN(' & byteRc & ')')
  !***DEBUG***
#ENDIF
#!---------------------------------------------------------------------
#SET(%wrkVar1,'RETURN')
#SET(%wrkVar2,'(byteRc)')
  %wrkVar1 %wrkVar2
#!---------------------------------------------------------------------
#INSERT(%LocalMapCheck(ABC))
#!---------------------------------------------------------------------
#GROUP(%DLLSourceEnd)
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#UTILITY(DLLGlobalDctArea,'2002.07.02: Export DCT Data Groups')
#!--------------------------------------------------------------------
#PREPARE
#ENDPREPARE
#!--------------------------------------------------------------------
#SHEET
#TAB('General')
  #BOXED('')
    #DISPLAY('Solution created by: Roberto Artigas Jr.')
    #DISPLAY('E-Mail at location: rartiga1@midsouth.rr.com')
    #DISPLAY('Template created by: Roberto Artigas Jr.')
    #DISPLAY('Copyright 1999 - 2003  by Roberto Artigas Jr.')
    #DISPLAY('All Rights reserved world wide.')
    #DISPLAY('')
    #DISPLAY('This is a part of a multi-dictionary application solution.')
    #DISPLAY('Each dictionary being in it''s own DLL.')
    #DISPLAY('')
    #DISPLAY('This part creates:')
    #DISPLAY('1) A file for each global area will all variables.')
  #ENDBOXED
#ENDTAB
#ENDSHEET
#!--------------------------------------------------------------------
#DECLARE(%HaveFirst)
#DECLARE(%BuildWork)
#DECLARE(%BuildOutput)
#DECLARE(%GGrpOpt)
#DECLARE(%GPos)
#DECLARE(%GPreOpt)
#DECLARE(%GAftOpt)
#!--------------------------------------------------------------------
#SET(%HaveFirst,    %FALSE)
#SET(%BuildWork,   'DCT_AREA.$LO')
#SET(%BuildOutput, 'DCT_AREA.GLO')
#!--------------------------------------------------------------------
#FOR(%GlobalData)
  #IF(%GlobalDataLevel=1)
    #IF(INSTRING('GROUP',%GlobalDataStatement,1,1)>0)
      #SET(%HaveFirst,%TRUE)
      #SET(%GGrpOpt,%GlobalData)
      #SET(%GPos,INSTRING(':',%GGrpOpt,1,1))
      #SET(%GPreOpt,SUB(%GGrpOpt,1,(%GPos-1)))
      #SET(%GAftOpt,SUB(%GGrpOpt,(%GPos+1),LEN(%GGrpOpt)))
      #SET(%BuildOutput,%GPreOpt & '_' & %GAftOpt & '.GLO')
      #CREATE(%BuildWork)
! BOF
!
! File:         %BuildOutput
! Dictionary:   %DictionaryFile
!
    #ENDIF
  #ENDIF
#!
%[18 + (%GlobalDataLevel * 2)]GlobalData %GlobalDataStatement
#!
  #IF(%GlobalDataLevel=1)
    #IF(INSTRING('END',%GlobalDataStatement,1,1)>0)
!
! EOF
      #CLOSE(%BuildWork)
      #REPLACE(%BuildOutput, %BuildWork)
      #REMOVE(%BuildWork)
      #SET(%HaveFirst,%FALSE)
    #ENDIF
  #ENDIF
#ENDFOR
#!
#IF(%HaveFirst)
#ENDIF
#!--------------------------------------------------------------------
#ATSTART
#ENDAT
#!--------------------------------------------------------------------
#ATEND
#ENDAT
#!--------------------------------------------------------------------
#GROUP(%DLLGlobalDctAreaEnd)
#!--------------------------------------------------------------------

#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#EXTENSION(DLLGlobalDctVars,'2002.07.02: RTC Set/Get DCT Variables'),APPLICATION
#!--------------------------------------------------------------------
#PREPARE
#ENDPREPARE
#!--------------------------------------------------------------------
#SHEET
#TAB('General')
  #BOXED('')
    #DISPLAY('Solution created by: Roberto Artigas Jr.')
    #DISPLAY('E-Mail at location: rartiga1@midsouth.rr.com')
    #DISPLAY('Template created by: Roberto Artigas Jr.')
    #DISPLAY('Copyright 1999 - 2003  by Roberto Artigas Jr.')
    #DISPLAY('All Rights reserved world wide.')
    #DISPLAY('')
    #DISPLAY('This is a part of a multi-dictionary application solution.')
    #DISPLAY('Each dictionary being in it''s own DLL.')
    #DISPLAY('')
    #DISPLAY('This part creates:')
    #DISPLAY('1) A "Get" and "Set" routine for each global variable.')
    #DISPLAY('2) An export file will all the generated routines.')
    #DISPLAY('3) A prototype (RTC) file with all the exported routines.')
  #ENDBOXED
#ENDTAB
#TAB('Parameters')
  #BOXED('')
    #PROMPT('Generate Debug Code? ',CHECK),%DebugCode,DEFAULT(0),AT(10)
  #ENDBOXED
  #BOXED('DLL Data Set/Get Procedures')
    #DISPLAY('')
    #PROMPT('Include Filename: ',@S12), %IncludeFilename, REQ, DEFAULT('GLO_VARS.RTC')
    #PROMPT('Routine Prefix: ',@S5), %RnPre, REQ, DEFAULT(UPPER(SLICE(%Program, 1, INSTRING('.', %Program, 1, 1)-1)))
    #DISPLAY('')
    #DISPLAY('')
    #PROMPT('Variables per Module: ',@N7),%VarsInModule,REQ,DEFAULT(20)
    #PROMPT('Files per Module: ',@n7),%FilesInModule,REQ,DEFAULT(20)
    #DISPLAY('')
  #ENDBOXED
#ENDTAB
#ENDSHEET
#!--------------------------------------------------------------------
#IF(NOT %gVarGlobal)
  #SET(%gVarWinIni,'')
  #SET(%gVarWinSys,'')
  #SET(%gVarWinTmp,'')
  #SET(%gVarDatFe1,'')
  #SET(%gVarDatFe2,'')
#ENDIF
#!--------------------------------------------------------------------
#COMMENT(61)
#!--------------------------------------------------------------------
#ATSTART
#CALL(%ReadABCFiles(ABC))
#ENDAT
#!--------------------------------------------------------------------
#!
#AT(%CustomGlobalDeclarations)
#!
#DECLARE(%GDLLName,   STRING)
#DECLARE(%GDataName,  STRING)
#DECLARE(%GDataType,  STRING)
#DECLARE(%GDataProto, STRING)
#DECLARE(%GDataValue, STRING)
#DECLARE(%GDataRc,    STRING)
#DECLARE(%GDataLink,  STRING)
#DECLARE(%GDataWork1, STRING)
#DECLARE(%GDataWork2, STRING)
#DECLARE(%GPos,       LONG)
#DECLARE(%LocB,       LONG)
#DECLARE(%LocE,       LONG)
#!
#DECLARE(%RaFileName, STRING)
#DECLARE(%RaClipName, STRING)
#DECLARE(%RaWorkName, STRING)
#!
#DECLARE(%UserOpt,    STRING)
#DECLARE(%FileOpt,    STRING)
#DECLARE(%WorkOpt,    STRING)
#DECLARE(%DataOpt,    STRING)
#DECLARE(%ReplOpt,    STRING)
#DECLARE(%GGrpOpt,    STRING)
#DECLARE(%GPreOpt,    STRING)
#DECLARE(%GGlobal,    STRING)
#!
#DECLARE(%gCallMe,    STRING)
#DECLARE(%gProc,      STRING)
#DECLARE(%gProto,     STRING)
#!
#DECLARE(%TheDate,    STRING)
#DECLARE(%TheTime,    STRING)
#SET(%TheDate,FORMAT(TODAY(),@D10))
#SET(%TheTime,FORMAT(CLOCK(),@T06))
#!
#DECLARE(%GDCount,    LONG)
#SET(%GDCount,0)
#DECLARE(%GDLoop,     LONG)
#SET(%GDLoop,1)
#DECLARE(%GDOpen,     LONG)
#SET(%GDOpen,0)
#!
#MESSAGE('DLL DATA Access Module Definitions',1)
#FOR(%GlobalData)
  #IF(INSTRING('GROUP',%GlobalDataStatement,1,1)>0)
    #SET(%GGrpOpt,%GlobalData)
    #SET(%GPos,INSTRING(':',%GGrpOpt,1,1))
    #SET(%GPreOpt,SUB(%GGrpOpt,1,(%GPos-1)))
    #CYCLE
  #ENDIF
  #IF(INSTRING('END',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
#!
  #SET(%GGlobal,%GPreOpt & ':' & %GlobalData)
  #MESSAGE('Creating: ' & %GlobalData , 2)
  #IF(%GDLoop=1)
    #SET(%GDOpen,1)
    #SET(%GDCount,%GDCount+1)
    #SET(%RaClipName, UPPER(SLICE(%Program, 1, 5)))
    #SET(%RaClipName, %RaClipName & 'G' & FORMAT(%GDCount,@n02))
    #SET(%RaFileName, %RaClipName & '.CLW')
    #SET(%RaWorkName, %RaClipName & '.$$$')
    #PROJECT(%RaFileName)
    #CREATE(%RaWorkName)

  MEMBER('%Application.CLW')
#!#INSERT(%zFilesUsed)                                    #! TESTING
  #ENDIF
#!
  #SET(%GDataName,%GlobalData)
  #SET(%GPos,INSTRING(':',%GDataName,1,1))
  #IF(%GPos)
    #SET(%GDataName,(SUB(%GDataName,1,(%GPos-1)) & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
  #ENDIF
  #SET(%GDLLName,('' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
#!
  #IF(INSTRING('CSTRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*CSTRING),PROC,BYTE')
    #SET(%GDataValue,'cstrValue')
  #ELSIF(INSTRING('STRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #ELSIF(INSTRING('USHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*USHORT),PROC,BYTE')
    #SET(%GDataValue,'ushtValue')
  #ELSIF(INSTRING('SHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SHORT),PROC,BYTE')
    #SET(%GDataValue,'sshtValue')
  #ELSIF(INSTRING('ULONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*ULONG),PROC,BYTE')
    #SET(%GDataValue,'ulngValue')
  #ELSIF(INSTRING('LONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*LONG),PROC,BYTE')
    #SET(%GDataValue,'slngValue')
  #ELSIF(INSTRING('REAL',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*REAL),PROC,BYTE')
    #SET(%GDataValue,'realValue')
  #ELSIF(INSTRING('BYTE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*BYTE),PROC,BYTE')
    #SET(%GDataValue,'byteValue')
  #ELSIF(INSTRING('UNSIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*UNSIGNED),PROC,BYTE')
    #SET(%GDataValue,'uValue')
  #ELSIF(INSTRING('SIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SIGNED),PROC,BYTE')
    #SET(%GDataValue,'sValue')
  #ELSIF(INSTRING('DATE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*DATE),PROC,BYTE')
    #SET(%GDataValue,'dateValue')
  #ELSIF(INSTRING('TIME',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*TIME),PROC,BYTE')
    #SET(%GDataValue,'timeValue')
  #ELSE
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #END

  #SET(%GDataLink,LINKNAME(%RnPre & '_Get_' & %GDLLName & %GDataProto))
!
! Procedure:    %RnPre_Get_%GDLLName
! Purpose:      Get '%GlobalData' variable to user
! Group:        %GGrpOpt,PRE(%GPreOpt)
! Variable:     %GGlobal
! Author:       Roberto Artigas Jr
! Link Name:    %GDataLink
!
%RnPre_Get_%[18]GDLLName PROCEDURE(%GDataValue)
  CODE
  %[22]GDataValue = %GGlobal
  RETURN(TRUE)

  #SET(%GDataLink,LINKNAME(%RnPre & '_Set_' & %GDLLName & %GDataProto))
!
! Procedure:    %RnPre_Set_%GDLLName
! Purpose:      Set '%GlobalData' variable from user
! Group:        %GGrpOpt,PRE(%GPreOpt)
! Variable:     %GGlobal
! Author:       Roberto Artigas Jr
! Link Name:    %GDataLink
!
%RnPre_Set_%[18]GDLLName PROCEDURE(%GDataValue)
  CODE
  %[22]GGlobal = %GDataValue
  RETURN(TRUE)

  #SET(%GDLoop,%GDLoop+1)
  #IF(%GDLoop=(%VarsInModule+1))
    #IF(%GDOpen)
      #CLOSE (%RaWorkName)
      #REPLACE (%RaFileName, %RaWorkName)
      #REMOVE (%RaWorkName)
      #SET(%GDOpen,0)
    #ENDIF
    #SET(%GDLoop,1)
  #ENDIF
#ENDFOR
#!
#IF(%GDOpen)
  #CLOSE (%RaWorkName)
  #REPLACE (%RaFileName, %RaWorkName)
  #REMOVE (%RaWorkName)
  #SET(%GDOpen,0)
#ENDIF
#COMMENT(61)
#!
#! Build include File
#! ------------------
  #MESSAGE('Prototypes for RTCALL (RTC) include file',1)
  #CREATE(%BuildInclude)
#!BOF
#!
#! File:         %IncludeFileName
#! Purpose:      Include Of DLL DCT Variable Set/Get Procedures
#! Author:       Roberto Artigas Jr
#!
  #SET(%GDataName, '')
  #SET(%GDataProto,',DLL')
  #SET(%GDataValue,'')
#! ------------------------------------------- !
#! This section does global get/set procedures !
#! ------------------------------------------- !
#FOR(%GlobalData)
  #IF(INSTRING('GROUP',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
  #IF(INSTRING('END',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
#!
  #MESSAGE('Creating: ' & %GlobalData , 2)
  #SET(%GDataName,%GlobalData)
  #SET(%GPos,INSTRING(':',%GDataName,1,1))
  #IF(%GPos)
    #SET(%GDataName,(SUB(%GDataName,1,(%GPos-1)) & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
  #ENDIF
  #SET(%GDLLName,('' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
#!
  #IF(INSTRING('CSTRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*CSTRING),PROC,BYTE')
    #SET(%GDataValue,'cstrValue')
  #ELSIF(INSTRING('STRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #ELSIF(INSTRING('USHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*USHORT),PROC,BYTE')
    #SET(%GDataValue,'ushtValue')
  #ELSIF(INSTRING('SHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SHORT),PROC,BYTE')
    #SET(%GDataValue,'sshtValue')
  #ELSIF(INSTRING('ULONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*ULONG),PROC,BYTE')
    #SET(%GDataValue,'ulngValue')
  #ELSIF(INSTRING('LONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*LONG),PROC,BYTE')
    #SET(%GDataValue,'slngValue')
  #ELSIF(INSTRING('REAL',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*REAL),PROC,BYTE')
    #SET(%GDataValue,'realValue')
  #ELSIF(INSTRING('BYTE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*BYTE),PROC,BYTE')
    #SET(%GDataValue,'byteValue')
  #ELSIF(INSTRING('UNSIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*UNSIGNED),PROC,BYTE')
    #SET(%GDataValue,'uValue')
  #ELSIF(INSTRING('SIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SIGNED),PROC,BYTE')
    #SET(%GDataValue,'sValue')
  #ELSIF(INSTRING('DATE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*DATE),PROC,BYTE')
    #SET(%GDataValue,'dateValue')
  #ELSIF(INSTRING('TIME',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*TIME),PROC,BYTE')
    #SET(%GDataValue,'timeValue')
  #ELSE
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #END
#!
  #SET(%gCallMe,'JPI')
  #SET(%gProc,%RnPre & '_Get_' & %GDLLName)
  #SET(%gProto,%GDataProto)
  #SET(%OOPConstruct,%gProc & '|' & UPPER(%Application) & '|' & %gCallMe & '|' & %gProto)
%OOPConstruct
  #SET(%gCallMe,'JPI')
  #SET(%gProc,%RnPre & '_Set_' & %GDLLName)
  #SET(%gProto,%GDataProto)
  #SET(%OOPConstruct,%gProc & '|' & UPPER(%Application) & '|' & %gCallMe & '|' & %gProto)
%OOPConstruct
#ENDFOR
#!
#!EOF
  #CLOSE(%BuildInclude)
  #REPLACE(%IncludeFilename, %BuildInclude)
  #REMOVE(%BuildInclude)
#ENDAT
#!--------------------------------------------------------------------
#AT(%AfterGlobalIncludes)
#ENDAT
#!--------------------------------------------------------------------
#MESSAGE('MAP Module Definitions',1)
#AT(%GlobalMap)
  #SET(%GDCount,0)
  #SET(%GDLoop,1)
  #SET(%GDOpen,0)
  #FOR(%GlobalData)
    #IF(INSTRING('GROUP',%GlobalDataStatement,1,1)>0)
      #CYCLE
    #ENDIF
    #IF(INSTRING('END',%GlobalDataStatement,1,1)>0)
      #CYCLE
    #ENDIF
#!
    #MESSAGE('Creating: ' & %GlobalData ,2)
    #IF(%GDLoop=1)
      #SET(%GDOpen,1)
      #SET(%GDCount,%GDCount+1)
      #!#SET(%RaClipName, 'GDLL_'&FORMAT(%GDCount,@n03))
      #SET(%RaClipName, UPPER(SLICE(%Program, 1, 5)))
      #SET(%RaClipName, %RaClipName & 'G' & FORMAT(%GDCount,@n02))
      #SET(%RaFileName, %RaClipName & '.CLW')
MODULE('%RaFileName')
    #ENDIF
#!
    #SET(%GDataName,%GlobalData)
    #SET(%GPos,INSTRING(':',%GDataName,1,1))
    #IF(%GPos)
      #SET(%GDataName,(SUB(%GDataName,1,(%GPos-1)) & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
    #ENDIF
    #SET(%GDLLName,('' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
#!
    #IF(INSTRING('CSTRING',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*CSTRING),PROC,BYTE')
      #SET(%GDataValue,'cstrValue')
    #ELSIF(INSTRING('STRING',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*STRING),PROC,BYTE')
      #SET(%GDataValue,'strValue')
    #ELSIF(INSTRING('USHORT',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*USHORT),PROC,BYTE')
      #SET(%GDataValue,'ushtValue')
    #ELSIF(INSTRING('SHORT',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*SHORT),PROC,BYTE')
      #SET(%GDataValue,'sshtValue')
    #ELSIF(INSTRING('ULONG',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*ULONG),PROC,BYTE')
      #SET(%GDataValue,'ulngValue')
    #ELSIF(INSTRING('LONG',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*LONG),PROC,BYTE')
      #SET(%GDataValue,'slngValue')
    #ELSIF(INSTRING('REAL',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*REAL),PROC,BYTE')
      #SET(%GDataValue,'realValue')
    #ELSIF(INSTRING('BYTE',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*BYTE),PROC,BYTE')
      #SET(%GDataValue,'byteValue')
    #ELSIF(INSTRING('UNSIGNED',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*UNSIGNED),PROC,BYTE')
      #SET(%GDataValue,'uValue')
    #ELSIF(INSTRING('SIGNED',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*SIGNED),PROC,BYTE')
      #SET(%GDataValue,'sValue')
    #ELSIF(INSTRING('DATE',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*DATE),PROC,BYTE')
      #SET(%GDataValue,'dateValue')
    #ELSIF(INSTRING('TIME',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*TIME),PROC,BYTE')
      #SET(%GDataValue,'timeValue')
    #ELSE
      #SET(%GDataProto,'(*STRING),PROC,BYTE')
      #SET(%GDataValue,'strValue')
    #END
#!
    #INDENT(-5)
%RnPre_Get_%[18]GDLLName PROCEDURE%GDataProto
%RnPre_Set_%[18]GDLLName PROCEDURE%GDataProto
    #INDENT(5)
#!
  #SET(%GDLoop,%GDLoop+1)
  #IF(%GDLoop=(%VarsInModule+1))
    #IF(%GDOpen)
END
      #SET(%GDOpen,0)
    #ENDIF
    #SET(%GDLoop,1)
  #ENDIF
#ENDFOR
#IF(%GDOpen)
END
  #SET(%GDOpen,0)
#ENDIF
#ENDAT
#!--------------------------------------------------------------------
#AT(%BeginningExports)
#INDENT(-2)
;Set/Get DCT Variables Routines Exports Begin
#INDENT(+2)
#! ------------------------------------------- !
#! This section does global get/set procedures !
#! ------------------------------------------- !
#MESSAGE('DLL Get/Set DCT Variable Definitions',1)
#FOR(%GlobalData)
  #IF(INSTRING('GROUP',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
  #IF(INSTRING('END',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
#!
  #MESSAGE('Creating: ' & %GlobalData , 2)
  #SET(%GDataName,%GlobalData)
  #SET(%GPos,INSTRING(':',%GDataName,1,1))
  #IF(%GPos)
    #SET(%GDataName,(SUB(%GDataName,1,(%GPos-1)) & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
  #ENDIF
  #SET(%GDLLName,('' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
#!
  #IF(INSTRING('CSTRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*CSTRING),PROC,BYTE')
    #SET(%GDataValue,'cstrValue')
  #ELSIF(INSTRING('STRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #ELSIF(INSTRING('USHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*USHORT),PROC,BYTE')
    #SET(%GDataValue,'ushtValue')
  #ELSIF(INSTRING('SHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SHORT),PROC,BYTE')
    #SET(%GDataValue,'sshtValue')
  #ELSIF(INSTRING('ULONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*ULONG),PROC,BYTE')
    #SET(%GDataValue,'ulngValue')
  #ELSIF(INSTRING('LONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*LONG),PROC,BYTE')
    #SET(%GDataValue,'slngValue')
  #ELSIF(INSTRING('REAL',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*REAL),PROC,BYTE')
    #SET(%GDataValue,'realValue')
  #ELSIF(INSTRING('BYTE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*BYTE),PROC,BYTE')
    #SET(%GDataValue,'byteValue')
  #ELSIF(INSTRING('UNSIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*UNSIGNED),PROC,BYTE')
    #SET(%GDataValue,'uValue')
  #ELSIF(INSTRING('SIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SIGNED),PROC,BYTE')
    #SET(%GDataValue,'sValue')
  #ELSIF(INSTRING('DATE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*DATE),PROC,BYTE')
    #SET(%GDataValue,'dateValue')
  #ELSIF(INSTRING('TIME',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*TIME),PROC,BYTE')
    #SET(%GDataValue,'timeValue')
  #ELSE
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #END
  #SET(%GDataLink,LINKNAME(%RnPre & '_Get_' & %GDLLName & %GDataProto))
%[55]GDataLink @?
  #SET(%GDataLink,LINKNAME(%RnPre & '_Set_' & %GDLLName & %GDataProto))
%[55]GDataLink @?
#ENDFOR
#INDENT(-2)
;Set/Get DCT Variables Routines Exports Ended
#INDENT(+2)
#ENDAT
#!--------------------------------------------------------------------
#AT(%ProgramSetup),LAST
#ENDAT
#!--------------------------------------------------------------------
#AT(%ProgramEnd),LAST
#ENDAT
#!--------------------------------------------------------------------
#AT(%GlobalData)
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#GROUP(%zFilesUsed)
#IF(%FALSE)
!RAS-BOE
  #FOR(%File)
!RAS: Dict File = %File
  #ENDFOR
  #FOR(%UsedFile)
!RAS: Used File = %UsedFile
  #ENDFOR
  #FOR(%UsedFile)
    #FIX(%File,%UsedFile)
!RAS %UsedFile='%File' Prefix='%FilePrefix'
  #ENDFOR
!RAS-EOE
#ENDIF
#!--------------------------------------------------------------------
#GROUP(%DLLGlobalDctVarsEnd)
#!--------------------------------------------------------------------

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#PROCEDURE(DLLSetGlobalRequest,'2002.07.06: DLL Set GlobalRequest Procedure (ABC)')
#!---------------------------------------------------------------------
#SHEET
#TAB('General')
  #BOXED('')
    #DISPLAY('Solution created by: Roberto Artigas Jr.')
    #DISPLAY('E-Mail at location: rartiga1@midsouth.rr.com')
    #DISPLAY('Template created by: Roberto Artigas Jr.')
    #DISPLAY('Copyright 1999 - 2003  by Roberto Artigas Jr.')
    #DISPLAY('All Rights reserved world wide.')
    #DISPLAY('')
    #DISPLAY('This is a part of a multi-dictionary application solution.')
    #DISPLAY('Each dictionary being in it''s own DLL.')
    #DISPLAY('')
    #DISPLAY('This part creates:')
    #DISPLAY('1) A source routine that sets GlobalRequest variable.')
  #ENDBOXED
#ENDTAB
#TAB('Parameters')
  #BOXED('')
    #PROMPT('Debug Me? ',CHECK),%DebugMe,DEFAULT(0)
    #PROMPT('Debug On? ',CHECK),%DebugOn,DEFAULT(0)
    #PROMPT('Parameters: ',@s255),%Parameters,DEFAULT('pWhere,pRequest')
    #DISPLAY('The prototype should be at least defined as:')
    #DISPLAY('(STRING,BYTE),BYTE')
    #DISPLAY('Otherwise you will get compile errors.')
    #DISPLAY('')
  #ENDBOXED
#ENDTAB
#ENDSHEET
#!--------------------------------------------------------------------
#DECLARE(%wrkVar1)
#DECLARE(%wrkVar2)
#!---------------------------------------------------------------------
#IF(%Parameters)
%[23]Procedure PROCEDURE  (%Parameters)
#ELSE
%[23]Procedure PROCEDURE  ()
#ENDIF
#!---------------------------------------------------------------------
!-----------------------------------------------------------------------------------!
! When you make a change, you are required to enter a change history entry.         !
! Change history entered lastest change first. Format is: ???.YYYY.MM.DD - <text>.  !
! Where: ??? are your initials, YYYY is the year, MM is the month, DD is the day,   !
! and <text> is some description of the changes you have made.                      !
!-----------------------------------------------------------------------------------!
#EMBED(%ChangeHistory,'Change History'),DATA,TREE('Change History{{PRIORITY(10)}')
#!---------------------------------------------------------------------
#INSERT(%FileControlInitialize(ABC))
#AT(%CustomGlobalDeclarations)
  #INSERT(%FileControlSetFlags(ABC))
#ENDAT
#!---------------------------------------------------------------------
#IF(%DebugMe)
#SET(%wrkVar1,'The_Debug')
#SET(%wrkVar2,'EQUATE(' & %DebugOn & ')')
%[23]wrkVar1 %wrkVar2
!
#ENDIF
#!---------------------------------------------------------------------
#FOR(%LocalData)
%[23]LocalData %LocalDataStatement
#ENDFOR
#!---------------------------------------------------------------------
#SET(%wrkVar1,'byteRc')
#SET(%wrkVar2,'BYTE(0)')
%[23]wrkVar1 %wrkVar2
#!---------------------------------------------------------------------
#EMBED(%DataSection,'Data Section'),DATA,TREE('Local Data{{PRIORITY(1000)}')
  CODE
#IF(%DebugMe)
  COMPILE('!***DEBUG***', The_Debug)
  STOP('%Procedure [ENTRY]<13,10>Called By: ' & CLIP(pWhere) & '')
  !***DEBUG***
#ENDIF
#!---------------------------------------------------------------------
#SET(%wrkVar1,'byteRc')
#SET(%wrkVar2,'= GlobalRequest')
  %[21]wrkVar1 %wrkVar2 #<! Return the current setting
#SET(%wrkVar1,'GlobalRequest')
#SET(%wrkVar2,'= pRequest')
  %[21]wrkVar1 %wrkVar2 #<! Set up caller request
#!---------------------------------------------------------------------
#EMBED(%ProcessedCode,'Processed Code'),LABEL     #! Embedded Source Code
#!---------------------------------------------------------------------
#IF(%DebugMe)
  COMPILE('!***DEBUG***', The_Debug)
  STOP('%Procedure [EXITS]<13,10>Called By: ' & CLIP(pWhere) & '<13,10>RETURN(' & byteRc & ')')
  !***DEBUG***
#ENDIF
#!---------------------------------------------------------------------
#SET(%wrkVar1,'RETURN')
#SET(%wrkVar2,'(byteRc)')
  %wrkVar1 %wrkVar2
#!---------------------------------------------------------------------
#INSERT(%LocalMapCheck(ABC))
#!---------------------------------------------------------------------
#GROUP(%DLLSetGlobalRequestEnd)
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#PROCEDURE(DLLGetGlobalResponse,'2002.07.06: DLL Get GlobalResponse Procedure (ABC)')
#!---------------------------------------------------------------------
#SHEET
#TAB('General')
  #BOXED('')
    #DISPLAY('Solution created by: Roberto Artigas Jr.')
    #DISPLAY('E-Mail at location: rartiga1@midsouth.rr.com')
    #DISPLAY('Template created by: Roberto Artigas Jr.')
    #DISPLAY('Copyright 1999 - 2003  by Roberto Artigas Jr.')
    #DISPLAY('All Rights reserved world wide.')
    #DISPLAY('')
    #DISPLAY('This is a part of a multi-dictionary application solution.')
    #DISPLAY('Each dictionary being in it''s own DLL.')
    #DISPLAY('')
    #DISPLAY('This part creates:')
    #DISPLAY('1) A source routine that gets GlobalResponse variable.')
  #ENDBOXED
#ENDTAB
#TAB('Parameters')
  #BOXED('')
    #PROMPT('Debug Me? ',CHECK),%DebugMe,DEFAULT(0)
    #PROMPT('Debug On? ',CHECK),%DebugOn,DEFAULT(0)
    #PROMPT('Parameters: ',@s255),%Parameters,DEFAULT('pWhere')
    #DISPLAY('The prototype should be at least defined as:')
    #DISPLAY('(STRING),BYTE')
    #DISPLAY('Otherwise you will get compile errors.')
    #DISPLAY('')
  #ENDBOXED
#ENDTAB
#ENDSHEET
#!---------------------------------------------------------------------
#DECLARE(%wrkVar1)
#DECLARE(%wrkVar2)
#!---------------------------------------------------------------------
#IF(%Parameters)
%[23]Procedure PROCEDURE  (%Parameters)
#ELSE
%[23]Procedure PROCEDURE  ()
#ENDIF
#!---------------------------------------------------------------------
!-----------------------------------------------------------------------------------!
! When you make a change, you are required to enter a change history entry.         !
! Change history entered lastest change first. Format is: ???.YYYY.MM.DD - <text>.  !
! Where: ??? are your initials, YYYY is the year, MM is the month, DD is the day,   !
! and <text> is some description of the changes you have made.                      !
!-----------------------------------------------------------------------------------!
#EMBED(%ChangeHistory,'Change History'),DATA,TREE('Change History{{PRIORITY(10)}')
#!---------------------------------------------------------------------
#INSERT(%FileControlInitialize(ABC))
#AT(%CustomGlobalDeclarations)
  #INSERT(%FileControlSetFlags(ABC))
#ENDAT
#!---------------------------------------------------------------------
#IF(%DebugMe)
#SET(%wrkVar1,'The_Debug')
#SET(%wrkVar2,'EQUATE(' & %DebugOn & ')')
%[23]wrkVar1 %wrkVar2
!
#ENDIF
#!---------------------------------------------------------------------
#FOR(%LocalData)
%[23]LocalData %LocalDataStatement
#ENDFOR
#!---------------------------------------------------------------------
#SET(%wrkVar1,'byteRc')
#SET(%wrkVar2,'BYTE(0)')
%[23]wrkVar1 %wrkVar2
#!---------------------------------------------------------------------
#EMBED(%DataSection,'Data Section'),DATA,TREE('Local Data{{PRIORITY(1000)}')
  CODE
#IF(%DebugMe)
  COMPILE('!***DEBUG***', The_Debug)
  STOP('%Procedure [ENTRY]<13,10>Called By: ' & CLIP(pWhere) & '')
  !***DEBUG***
#ENDIF
#!---------------------------------------------------------------------
#SET(%wrkVar1,'byteRc')
#SET(%wrkVar2,'= GlobalResponse')
  %[21]wrkVar1 %wrkVar2 #<! Return the current setting
#!---------------------------------------------------------------------
#EMBED(%ProcessedCode,'Processed Code'),LABEL     #! Embedded Source Code
#!---------------------------------------------------------------------
#IF(%DebugMe)
  COMPILE('!***DEBUG***', The_Debug)
  STOP('%Procedure [EXITS]<13,10>Called By: ' & CLIP(pWhere) & '<13,10>RETURN(' & byteRc & ')')
  !***DEBUG***
#ENDIF
#!---------------------------------------------------------------------
#SET(%wrkVar1,'RETURN')
#SET(%wrkVar2,'(byteRc)')
  %wrkVar1 %wrkVar2
#!---------------------------------------------------------------------
#INSERT(%LocalMapCheck(ABC))
#!---------------------------------------------------------------------
#GROUP(%DLLGetGlobalResponseEnd)
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#PROCEDURE(DLLSourceFiles,'2002.07.14: DLL Source Procedure with Files (ABC)')
#!---------------------------------------------------------------------
#PROMPT('Debug Me? ',CHECK),%DebugMe,DEFAULT(0)
#PROMPT('Debug On? ',CHECK),%DebugOn,DEFAULT(0)
#PROMPT('Parameters: ',@s255),%Parameters,DEFAULT('pWhere')
#DISPLAY('The prototype should be at least defined as:')
#DISPLAY('(STRING),BYTE')
#DISPLAY('Otherwise you will get compile errors.')
#DISPLAY('')
#DISPLAY('Template Chain: DLLSourceFiles(zAppDLL)')
#DISPLAY('Template File:  RYB_DLL.TPL')
#!--------------------------------------------------------------------
#ATSTART
#CALL(%ReadABCFiles(ABC))
#ENDAT
#!---------------------------------------------------------------------
#DECLARE(%wrkVar1)
#DECLARE(%wrkVar2)
#!---------------------------------------------------------------------
#IF(%Parameters)
%[23]Procedure PROCEDURE  (%Parameters)
#ELSE
%[23]Procedure PROCEDURE  ()
#ENDIF
#!---------------------------------------------------------------------
!-----------------------------------------------------------------------------------!
! When you make a change, you are required to enter a change history entry.         !
! Change history entered lastest change first. Format is: ???.YYYY.MM.DD - <text>.  !
! Where: ??? are your initials, YYYY is the year, MM is the month, DD is the day,   !
! and <text> is some description of the changes you have made.                      !
!-----------------------------------------------------------------------------------!
#EMBED(%ChangeHistory,'Change History'),DATA,TREE('Change History{{PRIORITY(10)}')
#!---------------------------------------------------------------------
#INSERT(%FileControlInitialize(ABC))
#AT(%CustomGlobalDeclarations)
  #INSERT(%FileControlSetFlags(ABC))
#ENDAT
#!---------------------------------------------------------------------
#IF(%DebugMe)
#SET(%wrkVar1,'The_Debug')
#SET(%wrkVar2,'EQUATE(' & %DebugOn & ')')
%[23]wrkVar1 %wrkVar2
!
#ENDIF
#!---------------------------------------------------------------------
#FOR(%LocalData)
%[23]LocalData %LocalDataStatement
#ENDFOR
#!---------------------------------------------------------------------
#SET(%wrkVar1,'byteRc')
#SET(%wrkVar2,'BYTE(TRUE)')
%[23]wrkVar1 %wrkVar2
#!---------------------------------------------------------------------
#EMBED(%DataSection,'Data Section'),DATA,TREE('Local Data{{PRIORITY(1000)}')
  CODE
#IF(%DebugMe)
  COMPILE('!***DEBUG***', The_Debug)
  STOP('%Procedure [ENTRY]<13,10>Called By: ' & CLIP(pWhere) & '')
  !***DEBUG***
#ENDIF
#!---------------------------------------------------------------------
#EMBED(%ProcessedCodeInit,'Processed Code Init'),LABEL     #! Embedded Source Code
#INDENT(+2)
#FOR(%OtherFiles)
  #FIX(%File,%OtherFiles)
  #CASE (SUB(%CWTemplateVersion,1,2))
  #OF  ('v2')
IF %OtherFiles::Used = 0
  CheckOpen(%OtherFiles,1) #<! %FileDescription
END
%OtherFiles::Used += 1
  #OF  ('v4')
  #OROF('v5')
  #OROF('v55')
Relate:%OtherFiles.Open #<! %FileDescription
  #ENDCASE
#ENDFOR
#INDENT(-2)
#EMBED(%ProcessedCodeWork,'Processed Code Work'),LABEL     #! Embedded Source Code
#INDENT(+2)
#FOR(%OtherFiles)
  #FIX(%File,%OtherFiles)
  #CASE (SUB(%CWTemplateVersion,1,2))
  #OF  ('v2')
%OtherFiles::Used -= 1
IF %OtherFiles::Used = 0 THEN #<! Usage Counter Zero?
  CLOSE(%OtherFiles) #<! %FileDeescription
END #<! Yes. Usage IS Zero
  #OF  ('v4')
  #OROF('v5')
  #OROF('v55')
Relate:%OtherFiles.Close #<! %FileDescription
  #ENDCASE
#ENDFOR
#INDENT(-2)
#EMBED(%ProcessedCodeKill,'Processed Code Kill'),LABEL     #! Embedded Source Code
#!---------------------------------------------------------------------
#IF(%DebugMe)
  COMPILE('!***DEBUG***', The_Debug)
  STOP('%Procedure [EXITS]<13,10>Called By: ' & CLIP(pWhere) & '<13,10>RETURN(' & byteRc & ')')
  !***DEBUG***
#ENDIF
#!---------------------------------------------------------------------
#SET(%wrkVar1,'RETURN')
#SET(%wrkVar2,'(byteRc)')
  %wrkVar1 %wrkVar2
#EMBED(%LocalProcedures,'Local Procedures'),LABEL     #! Embedded Source Code
#!---------------------------------------------------------------------
#INSERT(%LocalMapCheck(ABC))
#!---------------------------------------------------------------------
#GROUP(%DLLSourceFilesEnd)
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------

#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------

